class Obstacle //class for obstacles/red moving walls

{
    constructor(x, y) { //initial x and y position
        this.x = x; //set x position of obstacle
        this.y = y; //set y position of obstacle
        this.w = 100; //width of obstacle
        this.h = -500; //height of obstacle
        this.speed = 7; //starting speed of obstacle
    
    }

    hits(player) {
        // AABB collision detection between obstacle and player
        return (
          player.x > this.x && //players right edge touches obstacles left edge
          player.x < this.x + this.w && //players left edge touches obstacles right edge
          player.y > this.y + this.h && //players bottom edge touches obstacles top edge
          player.y < this.y // players top edge touches obstacles bottom edge
        );
    }
      


    show()
    {
        fill (175,54,60); // obstacle colour red
        noStroke(); //no outline
        rect(this.x, this.y, this.w, this.h);//size and start position

    }

    update(speedMultiplier = 1)
    {
            this.y += this.speed * speedMultiplier; //move obstacle faster
        

        if (this.y >= height) { //if obstacle moves off canvas reset it to start at the top
            this.y = -500;
            movingObstacle = random(obstacles); //pick new obstacle randomly
        }

       //keep obstacle within canvas boundaries
        this.x = constrain(this.x, 0, width - 1);//border
        this.y = constrain(this.y, 0, height - 1);//border
   
    }

}